/*
 * Copyright CEA/DAM/DIF  2010
 *  Author: Philippe Deniel (philippe.deniel@cea.fr)
 *
 * --------------------------
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 * 
 *
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef _SOLARIS
#include "solaris_port.h"
#endif

#include <stdio.h>
#include <string.h>
#include <pthread.h>
#include <fcntl.h>
#include <sys/file.h>           /* for having FNDELAY */
#include "HashData.h"
#include "HashTable.h"
#include "rpc.h"
#include "log_macros.h"
#include "stuff_alloc.h"
#include "nfs23.h"
#include "nfs4.h"
#include "nfs_core.h"
#include "cache_inode.h"
#include "cache_content.h"
#include "nfs_exports.h"
#include "nfs_creds.h"
#include "nfs_tools.h"
#include "mount.h"
#include "rquota.h"
#include "nfs_proto_functions.h"

/**
 * rquota_setactivequota: The Rquota setactivequota function, for all versions.
 *
 * The RQUOTA setactivequota function, for all versions.
 *
 *  @param parg        [IN]    ignored
 *  @param pexportlist [IN]    ignored
 *  @param pcontextp   [IN]    ignored
 *  @param pclient     [INOUT] ignored
 *  @param ht          [INOUT] ignored
 *  @param preq        [IN]    ignored
 *  @param pres        [OUT]   ignored
 *
 */

int rquota_setactivequota(nfs_arg_t * parg /* IN     */ ,
                          exportlist_t * pexport /* IN     */ ,
                          fsal_op_context_t * pcontext /* IN     */ ,
                          cache_inode_client_t * pclient /* INOUT  */ ,
                          hash_table_t * ht /* INOUT  */ ,
                          struct svc_req *preq /* IN     */ ,
                          nfs_res_t * pres /* OUT    */ )
{
  LogFullDebug(COMPONENT_NFSPROTO,
               "REQUEST PROCESSING: Calling rquota_setactivequota");
  /* 0 is success */
  return 0;
}

/**
 * rquota_setactivequota_Free: Frees the result structure allocated for rquota_setactivequota
 *
 * Frees the result structure allocated for rquota_setactivequota. Does Nothing in fact.
 *
 * @param pres        [INOUT]   Pointer to the result structure.
 *
 */
void rquota_setactivequota_Free(nfs_res_t * pres)
{
  return;
}
